#!BPY

"""
Name: 'Alignement'
Blender: 232
Group: 'Mesh'
"""
# Selectionnez un objet (Si aucun selectionne a pas tre bon).
#-Passez en mode d edition : touche TAB.
#-Selectionner les points a aligner.
#-Ensuite ouvrez Blender->Scripts Window->Alignement.
#-Selectionnez ensuite l axe d alignement et son option d alignement (vous pouvez entrer une valeur numerique bien sur).
#
# ==== NOUVEAUTE: =======================================================================================
#  - Vous pouvez aussi entrer 'Max' ou 'M' ou 'min' ou 'm' ou une valeur numerique (a tout moment).
#
#  _ Vous pouvez egalement basculer entre les modes 'Centrer', "Valeur numerique", 'min' et 'Max',
#       par une succession de double click gauche dans les "champs d'entrer" (la ou s'affiche "Centrer"...).
#
# =======================================================================================================
#-Pour valider cliquez avec le bouton droit dans la fenetre du script.
#-Pour quitter : touche Q.


import Blender
from Blender import Window
from Blender.Draw import *
from Blender.BGL import *

tog = "Global"
event_tog = 101

gloORloc = Create(0)
vx=vy=vz=Create(0)
xout=yout=zout=Create('Centrer')
lastxout = lastyout = lastzout = ''

chiffres = ['0','1','2','3','4','5','6','7','8','9','.','+','-']

plx=ply=plz= 0
choice = ['Centrer','min','Max']


BL_VERSION = Blender.Get('version')
if (BL_VERSION<=223):
	import Blender210

################
def editbegin():
################
	global edit_mode

	try:
		edit_mode = Window.EditMode()
		if edit_mode: Window.EditMode(0)
	except:
		print "=============================="
		print "'EditMode()' INCOMPATIBILITY !"
	return 0

##############
def editend():
##############

	try:
		if edit_mode: Window.EditMode(1)
	except:
		print "=============================="
		print "'EditMode()' INCOMPATIBILITY !"

	return 0

###########################
def GlobalPosition(P, obj):
###########################
	#
	# Prend les coordonnees locale d'un point (Vertice from Mesh)
	# Et les transforme en coordonnees global
	#
	if (BL_VERSION<=223):
		m = obj.matrix
	else:
		m = obj.getMatrix()

	try:    ############################## Version officielle ############################################

		PX = P[0]*m[0][0] + P[1]*m[1][0] + P[2]*m[2][0] + m[3][0]
		PY = P[0]*m[0][1] + P[1]*m[1][1] + P[2]*m[2][1] + m[3][1]
		PZ = P[0]*m[0][2] + P[1]*m[1][2] + P[2]*m[2][2] + m[3][2]
		return [PX, PY, PZ]


	except: ############################## Version TUHOPUU ############################################

		PX = P[0]*m[0] + P[1]*m[4] + P[2]*m[8] + m[12]
		PY = P[0]*m[1] + P[1]*m[5] + P[2]*m[9] + m[13]
		PZ = P[0]*m[2] + P[1]*m[6] + P[2]*m[10] + m[14]
		return [PX, PY, PZ]

##########################
def LocalPosition(P, obj):
##########################
	#
	# Prend les coordonnees global d'un point
	# Et les transforme en coordonnees locale  (Vertice from Mesh)
	#
	if (BL_VERSION<=223):
		m = Blender210.getObject(obj.name).inverseMatrix
	else:
		m = obj.getInverseMatrix()

	try:    ############################## Version officielle ############################################

		PX = P[0]*m[0][0] + P[1]*m[1][0] + P[2]*m[2][0] + m[3][0]
		PY = P[0]*m[0][1] + P[1]*m[1][1] + P[2]*m[2][1] + m[3][1]
		PZ = P[0]*m[0][2] + P[1]*m[1][2] + P[2]*m[2][2] + m[3][2]
		return [PX, PY, PZ]

	except: ############################## Version TUHOPUU ############################################

		PX = P[0]*m[0] + P[1]*m[4] + P[2]*m[8] + m[12]
		PY = P[0]*m[1] + P[1]*m[5] + P[2]*m[9] + m[13]
		PZ = P[0]*m[2] + P[1]*m[6] + P[2]*m[10] + m[14]
		return [PX, PY, PZ]


######################
def leftList(pl,list):
######################

	pl -= 1 + (-len(list) * (pl==-1))

	return pl,list[pl]

######################
def rightList(pl,list):
######################

	pl += 1 + (-len(list) * (pl==len(list)-1))

	return pl,list[pl]

################
def interface():
################
	global vx,vy,vz,xout,yout,zout, gloORloc

	glClearColor( 0.85, 0.86, 0.80, 0)
	glClear(GL_COLOR_BUFFER_BIT)


	apply(glColor3f, (1.0, 1.0, 1.0))
	glRasterPos2f(21, 229)
	Text('Alignement')
	glRasterPos2f(21, 229)
	Text('Alignement')
	apply(glColor3f, (0.0, 0.0, 0.0))
	glRasterPos2f(20, 230)
	Text('Alignement')

	gloORloc = Toggle(tog, event_tog, 100, 225, 60, 20, gloORloc.val, "Global or local co.")

	apply(glColor3f, (0.0, 0.0, 0.0))
	glRasterPos2f(20, 205)
	Text('Cliquez dans cette fenetre avec ')
	glRasterPos2f(20, 187)
	Text('le bouton droit de la souris pour valider.')

	apply(glColor3f, (0.0, 0.0, 1.0))
	glRasterPos2f(20, 155)
	Text('Click with the right mouse button ')
	glRasterPos2f(20, 137)
	Text('on this window to activate.')

	vx = Toggle('X', 10, 20, 94, 20 , 20, vx.val)
	vy = Toggle('Y', 20, 20, 72, 20 , 20, vy.val)
	vz = Toggle('Z', 30, 20, 50, 20 , 20, vz.val)
	if vx.val:
		xout = String('', 11, 45, 94, 100, 20, xout.val, 100, "Laissez 'Centrer' pour la moyenne des points ou entrez une valeur commune")
	if vy.val:
		yout = String('', 21, 45, 72, 100, 20, yout.val, 100, "Laissez 'Centrer' pour la moyenne des points ou entrez une valeur commune")
	if vz.val:
		zout = String('', 31, 45, 50, 100, 20, zout.val, 100, "Laissez 'Centrer' pour la moyenne des points ou entrez une valeur commune")

################
def ev(evt,val):
################

	if ( evt == ESCKEY and not val):
		Exit()

	if (evt == QKEY and not val): Exit()

	if (evt == 3 and not val):
		aligne(centre())


#############
def bev(evt):
#############
	global xout, yout, zout, plx, ply, plz, lastxout, lastyout, lastzout, tog, event_tog, gloORloc

	if evt == event_tog:
		if gloORloc.val:
			tog = "Local"
		else:
			tog = "Global"
		Draw()

	if evt == 10:
		xout.val = 'Centrer'
		plx = 0
		lastxout = xout.val
		Draw()

	if evt == 11:
		plx,xout.val,lastxout = checkNB(plx,xout.val,lastxout)

		Draw()

	if evt == 20:
		yout.val = 'Centrer'
		ply = 0
		lastyout = yout.val
		Draw()

	if evt == 21:
		ply,yout.val,lastyout = checkNB(ply,yout.val,lastyout)

		Draw()

	if evt == 30:
		zout.val = 'Centrer'
		plz = 0
		lastzout = zout.val
		Draw()

	if evt == 31:
		plz,zout.val,lastzout = checkNB(plz,zout.val,lastzout)

		Draw()

#################################
def checkNB(P,valeur,lastvaleur):
#################################

	if valeur != lastvaleur:
		if valeur:
			if not (valeur[0] == 'C' or valeur[0] == 'm' or valeur[0] == 'M' or valeur[0] in chiffres):
				P,ch = rightList(P,choice)
				valeur = str(ch)

	else:
			P,ch = rightList(P,choice)
			valeur = str(ch)


	lastvaleur = valeur

	return (P,valeur,lastvaleur)

#############
def centre():
#############

	i=[9,9,9]


	if vx.val:
		if xout.val == 'Centrer':i[0]=5
		elif xout.val:
			if xout.val == 'max' or xout.val == 'Max' or xout.val == 'MAX' or xout.val[0] == 'M':
				i[0]=4
			elif xout.val == 'min' or xout.val == 'Min' or xout.val == 'MIN' or xout.val[0] == 'm':
				i[0]=3
			elif xout.val[0] in chiffres:
				i[0]=2
	else:i[0]=1


	if vy.val:
		if yout.val == 'Centrer':i[1]=5
		elif yout.val:
			if yout.val == 'max' or yout.val == 'Max' or yout.val == 'MAX' or yout.val[0] == 'M':
				i[1]=4
			elif yout.val == 'min' or yout.val == 'Min' or yout.val == 'MIN' or yout.val[0] == 'm':
				i[1]=3
			elif yout.val[0] in chiffres:
				i[1]=2
	else:i[1]=1


	if vz.val:
		if zout.val == 'Centrer':i[2]=5
		elif zout.val:
			if zout.val == 'max' or zout.val == 'Max' or zout.val == 'MAX' or zout.val[0] == 'M':
				i[2]=4
			elif zout.val == 'min' or zout.val == 'Min' or zout.val == 'MIN' or zout.val[0] == 'm':
				i[2]=3
			elif zout.val[0] in chiffres:
				i[2]=2
	else:i[2]=1


	return i

################
def aligne(opt):
################

	if Blender.Object.GetSelected():
		if Blender.Object.GetSelected()[0].getType() == 'Mesh':

			editbegin()
			x=y=z=nbV=0

			Obj = Blender.Object.GetSelected()[0]
			objMesh = Obj.data

			firstvert = 1

			Vglobco = {}
			Vlocal = {}

			for vertice in objMesh.verts:
				if vertice.sel:

					Vglobco[vertice] = GlobalPosition(vertice.co, Obj)
					Vlocal[vertice] = vertice.co


					if firstvert:
						if gloORloc.val:
							MAXX = minX = Vlocal[vertice][0]
							MAXY = minY = Vlocal[vertice][1]
							MAXZ = minZ = Vlocal[vertice][2]
						else:
							MAXX = minX = Vglobco[vertice][0]
							MAXY = minY = Vglobco[vertice][1]
							MAXZ = minZ = Vglobco[vertice][2]
						firstvert = 0

					nbV += 1

					if gloORloc.val:
						if Vlocal[vertice][0] > MAXX:MAXX = Vlocal[vertice][0]
						if Vlocal[vertice][0] < minX:minX = Vlocal[vertice][0]
						if Vlocal[vertice][1] > MAXY:MAXY = Vlocal[vertice][1]
						if Vlocal[vertice][1] < minY:minY = Vlocal[vertice][1]
						if Vlocal[vertice][2] > MAXZ:MAXZ = Vlocal[vertice][2]
						if Vlocal[vertice][2] < minZ:minZ = Vlocal[vertice][2]
					else:
						if Vglobco[vertice][0] > MAXX:MAXX = Vglobco[vertice][0]
						if Vglobco[vertice][0] < minX:minX = Vglobco[vertice][0]
						if Vglobco[vertice][1] > MAXY:MAXY = Vglobco[vertice][1]
						if Vglobco[vertice][1] < minY:minY = Vglobco[vertice][1]
						if Vglobco[vertice][2] > MAXZ:MAXZ = Vglobco[vertice][2]
						if Vglobco[vertice][2] < minZ:minZ = Vglobco[vertice][2]


					if opt[0] == 2:
						if gloORloc.val:
							vertice.co[0] = float(xout.val)
							vertice.co[1] = float(Vlocal[vertice][1])
							vertice.co[2] = float(Vlocal[vertice][2])
						else:
							LocCofromGlobCo = LocalPosition([float(xout.val),float(Vglobco[vertice][1]),float(Vglobco[vertice][2])], Obj)
							vertice.co[0] = LocCofromGlobCo[0]
							vertice.co[1] = LocCofromGlobCo[1]
							vertice.co[2] = LocCofromGlobCo[2]

					elif opt[0] == 5:
						if gloORloc.val:
							x+=Vlocal[vertice][0]
						else:
							x+=Vglobco[vertice][0]

					if opt[1] == 2:
						if gloORloc.val:
							vertice.co[0] = float(Vlocal[vertice][0])
							vertice.co[1] = float(yout.val)
							vertice.co[2] = float(Vlocal[vertice][2])
						else:
							LocCofromGlobCo = LocalPosition([float(Vglobco[vertice][0]),float(yout.val),float(Vglobco[vertice][2])], Obj)
							vertice.co[0] = LocCofromGlobCo[0]
							vertice.co[1] = LocCofromGlobCo[1]
							vertice.co[2] = LocCofromGlobCo[2]

					elif opt[1] == 5:
						if gloORloc.val:
							y+=Vlocal[vertice][1]
						else:
							y+=Vglobco[vertice][1]

					if opt[2] == 2:
						if gloORloc.val:
							vertice.co[0] = float(Vlocal[vertice][0])
							vertice.co[1] = float(Vlocal[vertice][1])
							vertice.co[2] = float(zout.val)
						else:
							LocCofromGlobCo = LocalPosition([float(Vglobco[vertice][0]),float(Vglobco[vertice][1]),float(zout.val)], Obj)
							vertice.co[0] = LocCofromGlobCo[0]
							vertice.co[1] = LocCofromGlobCo[1]
							vertice.co[2] = LocCofromGlobCo[2]

					elif opt[2] == 5:
						if gloORloc.val:
							z+=Vlocal[vertice][2]
						else:
							z+=Vglobco[vertice][2]


			for vertice in objMesh.verts:
				if vertice.sel:
					################## CENTRER ##################
					if x!=0:
						if gloORloc.val:
							vertice.co[0] = float(x / nbV)
							vertice.co[1] = float(Vlocal[vertice][1])
							vertice.co[2] = float(Vlocal[vertice][2])
						else:
							LocCofromGlobCo = LocalPosition([x / nbV,float(Vglobco[vertice][1]),float(Vglobco[vertice][2])], Obj)
							vertice.co[0] = LocCofromGlobCo[0]
							vertice.co[1] = LocCofromGlobCo[1]
							vertice.co[2] = LocCofromGlobCo[2]

					if y!=0:
						if gloORloc.val:
							vertice.co[0] = float(Vlocal[vertice][0])
							vertice.co[1] = float(y / nbV)
							vertice.co[2] = float(Vlocal[vertice][2])
						else:
							LocCofromGlobCo = LocalPosition([float(Vglobco[vertice][0]),y / nbV,float(Vglobco[vertice][2])], Obj)
							vertice.co[0] = LocCofromGlobCo[0]
							vertice.co[1] = LocCofromGlobCo[1]
							vertice.co[2] = LocCofromGlobCo[2]

					if z!=0:
						if gloORloc.val:
							vertice.co[0] = float(Vlocal[vertice][0])
							vertice.co[1] = float(Vlocal[vertice][1])
							vertice.co[2] = float(z / nbV)
						else:
							LocCofromGlobCo = LocalPosition([float(Vglobco[vertice][0]),float(Vglobco[vertice][1]),z / nbV], Obj)
							vertice.co[0] = LocCofromGlobCo[0]
							vertice.co[1] = LocCofromGlobCo[1]
							vertice.co[2] = LocCofromGlobCo[2]


					################### min / Max ###############
					if opt[0] == 3:
						if gloORloc.val:
							vertice.co[0] = float(minX)
							vertice.co[1] = float(Vlocal[vertice][1])
							vertice.co[2] = float(Vlocal[vertice][2])
						else:
							LocCofromGlobCo = LocalPosition([minX,float(Vglobco[vertice][1]),float(Vglobco[vertice][2])], Obj)
							vertice.co[0] = LocCofromGlobCo[0]
							vertice.co[1] = LocCofromGlobCo[1]
							vertice.co[2] = LocCofromGlobCo[2]

					if opt[0] == 4:
						if gloORloc.val:
							vertice.co[0] = float(MAXX)
							vertice.co[1] = float(Vlocal[vertice][1])
							vertice.co[2] = float(Vlocal[vertice][2])
						else:
							LocCofromGlobCo = LocalPosition([MAXX,float(Vglobco[vertice][1]),float(Vglobco[vertice][2])], Obj)
							vertice.co[0] = LocCofromGlobCo[0]
							vertice.co[1] = LocCofromGlobCo[1]
							vertice.co[2] = LocCofromGlobCo[2]

					if opt[1] == 3:
						if gloORloc.val:
							vertice.co[0] = float(Vlocal[vertice][0])
							vertice.co[1] = float(minY)
							vertice.co[2] = float(Vlocal[vertice][2])
						else:
							LocCofromGlobCo = LocalPosition([float(Vglobco[vertice][0]),minY,float(Vglobco[vertice][2])], Obj)
							vertice.co[0] = LocCofromGlobCo[0]
							vertice.co[1] = LocCofromGlobCo[1]
							vertice.co[2] = LocCofromGlobCo[2]

					if opt[1] == 4:
						if gloORloc.val:
							vertice.co[0] = float(Vlocal[vertice][0])
							vertice.co[1] = float(MAXY)
							vertice.co[2] = float(Vlocal[vertice][2])
						else:
							LocCofromGlobCo = LocalPosition([float(Vglobco[vertice][0]),MAXY,float(Vglobco[vertice][2])], Obj)
							vertice.co[0] = LocCofromGlobCo[0]
							vertice.co[1] = LocCofromGlobCo[1]
							vertice.co[2] = LocCofromGlobCo[2]

					if opt[2] == 3:
						if gloORloc.val:
							vertice.co[0] = float(Vlocal[vertice][0])
							vertice.co[1] = float(Vlocal[vertice][1])
							vertice.co[2] = float(minZ)
						else:
							LocCofromGlobCo = LocalPosition([float(Vglobco[vertice][0]),float(Vglobco[vertice][1]),minZ], Obj)
							vertice.co[0] = LocCofromGlobCo[0]
							vertice.co[1] = LocCofromGlobCo[1]
							vertice.co[2] = LocCofromGlobCo[2]

					if opt[2] == 4:
						if gloORloc.val:
							vertice.co[0] = float(Vlocal[vertice][0])
							vertice.co[1] = float(Vlocal[vertice][1])
							vertice.co[2] = float(MAXZ)
						else:
							LocCofromGlobCo = LocalPosition([float(Vglobco[vertice][0]),float(Vglobco[vertice][1]),MAXZ], Obj)
							vertice.co[0] = LocCofromGlobCo[0]
							vertice.co[1] = LocCofromGlobCo[1]
							vertice.co[2] = LocCofromGlobCo[2]

			del(Vglobco)
			del(Vlocal)

			objMesh.update()
			Obj.makeDisplayList()
			editend()
			Blender.Redraw()

##########################
Register(interface,ev,bev)
##########################